!
subroutine LA64(A, Eps)
!      
!declaration
real, intent(inout):: A(:,:)
real, intent(in):: Eps
real RN, Sigma, Norma, Amax, Omega
real V1, V2, S1, S2, R, Sint, Cost
integer i, j, k, l, Ind, n, n1
!begin
  n=size(A,1); n1=n-1
  RN=float(n)
  S1=0.0
  do j=2, n
    do i=1, j-1
      S1=S1+A(i,j)**2
    end do
  end do
  if (S1==0.0) return
  Sigma=sqrt(2.0*S1)
  Norma=(Eps/RN)*Sigma
  Ind=0
10 continue
  Sigma=Sigma/RN
20 continue
  do l=2, n
    do k=1, l-1
      if (abs(A(k,l))<Sigma) cycle
      Ind=1
      V1=A(k,k); V2=A(l,l); Amax=A(k,l)
      R=0.5*(V1-V2); Omega=-1.0
      if (R/=0.0) Omega=-sign(1.0,R)*Amax/sqrt(R**2+Amax**2)
      Sint=Omega/sqrt(2.0*(1.0+sqrt(1.0-Omega**2)))
      Cost=sqrt(1.0-Sint**2)
      do j=1, k-1
        S1=A(j,k); S2=A(j,l)
        A(j,k)=S1*Cost-S2*Sint
        A(j,l)=S1*Sint+S2*Cost
      end do
      do j=k+1, l-1
        S1=A(k,j); S2=A(j,l)
        A(k,j)=S1*Cost-S2*Sint
        A(j,l)=S1*Sint+S2*Cost
      end do
      do j=l+1, n
        S1=A(k,j); S2=A(l,j)
        A(k,j)=S1*Cost-S2*Sint
        A(l,j)=S1*Sint+S2*Cost
      end do
      S1=Cost*Cost; S2=Sint*Sint; R=Cost*Sint
      Omega=2.0*Amax*R
      A(k,k)=V1*S1+V2*S2-Omega
      A(l,l)=V1*S2+V2*S1+Omega
      A(k,l)=(V1-V2)*R+Amax*(S1-S2)
    end do
  end do
  if (Ind/=0) then; Ind=0; goto 20; end if
  if (Sigma>Norma) goto 10
  return
end subroutine LA64
